import 'package:dynamic_widget/dynamic_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:layout_form_builder/datalayer/bean/eform_cache.dart';
import 'package:layout_form_builder/datalayer/constant/eform_parser.dart';
import 'package:layout_form_builder/datalayer/constant/eform_properties.dart';

class CardParser extends WidgetParser {
  @override
  String get widgetName => EFormWidgetParser.Card.value;

  @override
  Widget parse(Map<String, dynamic> map, BuildContext buildContext, ClickListener? listener) {
    final color = EFormCache.fieldColor(map, EFormProperties.PROP_COLOR) ?? Colors.white;
    final elevation = EFormCache.fieldDouble(map, EFormProperties.PROP_ELEVATION) ?? 5;
    final shape = RoundedRectangleBorder(borderRadius: BorderRadius.circular(EFormCache.fieldDouble(map, EFormProperties.PROP_ROUNDED_RECTANGLE_BORDER_RADIUS) ?? 15));
    final child = EFormCache.fieldDynamic(map, EFormProperties.PROP_CHILD);

    return Card(
      color: color,
      elevation: elevation,
      shape: shape,
      child: DynamicWidgetBuilder.buildFromMap(child, buildContext, listener));
  }

  @override
  Type get widgetType => Card;

  @override
  Map<String, dynamic>? export(Widget? widget, BuildContext? buildContext) {
    return Map<String, dynamic>();
  }
}
