import 'package:flutter/material.dart';

class Util {
  static Size size(BuildContext context) {
    return MediaQuery.of(context).size;
  }

  static double getWidthPctOfScreen(BuildContext context, double pct) {
    return size(context).width * pct / 100;
  }

  static double getHeightPctOfScreen(BuildContext context, double pct) {
    return size(context).height * pct / 100;
  }

  static execAfterMs(int ms, Function doAft) {
    Future.delayed(Duration(milliseconds: ms), doAft());
  }
}

extension HexColor on Color {
  /// String is in the format "aabbcc" or "ffaabbcc" with an optional leading "#".
  static Color fromHex(String hexString) {
    final buffer = StringBuffer();
    if (hexString.length == 6 || hexString.length == 7) buffer.write('ff');
    buffer.write(hexString.replaceFirst('#', ''));
    return Color(int.parse(buffer.toString(), radix: 16));
  }

  /// Prefixes a hash sign if [leadingHashSign] is set to `true` (default is `true`).
  String toHex({bool leadingHashSign = true}) => '${leadingHashSign ? '#' : ''}'
      '${alpha.toRadixString(16).padLeft(2, '0')}'
      '${red.toRadixString(16).padLeft(2, '0')}'
      '${green.toRadixString(16).padLeft(2, '0')}'
      '${blue.toRadixString(16).padLeft(2, '0')}';
}
